Clazz.declarePackage ("jalview.workers");
Clazz.load (["jalview.workers.ConsensusThread"], "jalview.workers.ComplementConsensusThread", ["jalview.analysis.AAFrequency"], function () {
c$ = Clazz.decorateAsClass (function () {
this.mappings = null;
Clazz.instantialize (this, arguments);
}, jalview.workers, "ComplementConsensusThread", jalview.workers.ConsensusThread);
Clazz.overrideMethod (c$, "getNewWorker", 
function () {
return  new jalview.workers.ComplementConsensusThread (this.alignViewport, this.ap);
});
Clazz.overrideMethod (c$, "getConsensusAnnotation", 
function () {
return this.alignViewport.getComplementConsensusAnnotation ();
});
Clazz.overrideMethod (c$, "getViewportConsensus", 
function () {
return this.alignViewport.getComplementConsensusHash ();
});
Clazz.defineMethod (c$, "initializeCalc", 
function () {
this.mappings = this.alignment.getCodonFrames ();
return (this.mappings != null && !this.mappings.isEmpty () && Clazz.superCall (this, jalview.workers.ComplementConsensusThread, "initializeCalc", []));
});
Clazz.overrideMethod (c$, "computeConsensus", 
function () {
for (var i = 0; i < 3; i++) {
try {
jalview.analysis.AAFrequency.calculateCdna (this.alignment, this.mappings, this.hconsensus, this.iFirst, this.iLast);
break;
} catch (e) {
if (Clazz.exceptionOf (e, java.util.ConcurrentModificationException)) {
} else {
throw e;
}
}
}
});
Clazz.overrideMethod (c$, "finalizeCalc", 
function () {
this.alignViewport.setComplementConsensusHash (this.hconsensus);
});
Clazz.overrideMethod (c$, "deriveConsensus", 
function (consensusAnnotation, consensusData) {
jalview.analysis.AAFrequency.completeCdnaConsensus (consensusAnnotation, consensusData, this.alignViewport.isShowSequenceLogo (), this.getSequences ().length);
}, "jalview.datamodel.AlignmentAnnotation,~A");
});
